/*---------------------------------------------------------------
This file is part of the Buildable Evolution Software Project. 

http://www.demo.cs.brandeis.edu/pr/buildable
(C) Pablo Funes and Jordan B. Pollack 1997-2008
pablo@cs.brandeis.edu

The methods and configurations incorporated in the Builable Evolution
Software Project are covered in part by United States patent
6,434,492 "Computer apparatus and method for analyzing structural
stability" of August 13, 2002. 

The Buildable Evolution Software Project is free software: you 
can redistribute it and/or modify it under the terms of the 
GNU General Public License as published by the Free Software 
Foundation, either version 3 of the License, or (at your option) 
any later version. 

The Buildable Evolution Software Project is distributed in the
hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more
details. 

You should have received a copy of the GNU General Public License 
along with the software. If not, see <http://www.gnu.org/licenses/>. 
---------------------------------------------------------------*/
package evocad;

import java.awt.BorderLayout;

import javax.swing.JFrame;

public class LegoMain {
	static boolean remote = false;
	static String RemoteURL = null;
	static String extension = ".cgi";
	static String execPath = "../../evocad-backend/bin/";
	
	public static void main(String[] argv) {
		int i;
		for (i=0;i<argv.length;i++) {
			if (argv[i].equals("-r")) remote=true;
			else if (argv[i].equals("-l")) remote=false;
			else if (argv[i].equals("-p") && ((i+1) < argv.length)) 
				execPath = argv [++i]; 
			else if (argv[i].equals("-u") && ((i+1) < argv.length)) 
				RemoteURL=argv[++i];
			else {
				System.err.println("Bad argument: <"+argv[i]+">");
				System.err.println("usage: java LegoMain [-w] [-r  [-u baseurl]]");
				System.err.println("-r: call remote server @ baseurl through cgi interface");
				System.exit(0);
			}
		}
		if (remote)
			System.out.println("remote mode, baseurl="+RemoteURL);
		else {
			String osname = System.getProperty("os.name");
			String ext = null;
			if (osname.startsWith("Windows")) {
				ext=".exe";
			}
			else if (osname.startsWith("Linux")) {
				ext=".cgi";
			}
			System.out.println("local mode OS="+osname+" ext="+ext);
			if (ext == null) throw new Error("Unknown OS "+osname);
			extension = ext;
		}
		LegoApplet applet = new LegoApplet(remote,RemoteURL);
		applet.setExtension(extension);
		if (! execPath.endsWith("/") &&
				! execPath.endsWith("\\"))
			execPath = execPath + "/";
		applet.setExecPrefix(execPath);
		applet.setSize(1000,500);
		applet.setVisible(true);
		JFrame f = new JFrame();
		f.add(applet);
		f.setLayout(new BorderLayout());
		f.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		f.setVisible(true);
		f.setSize(1010,510);
	}
}
